<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GeoCoordinatesType StructType
 * @subpackage Structs
 */
class GeoCoordinatesType extends AbstractStructBase
{
    /**
     * The Google
     * @var \StructType\GeoCoordinatesGoogleType
     */
    public $Google;
    /**
     * The DecimalDegree
     * @var \StructType\GeoCoordinatesDecimalDegreeType
     */
    public $DecimalDegree;
    /**
     * The DegreeMinuteSeconds
     * @var \StructType\GeoCoordinatesDegreeMinuteSecondsType
     */
    public $DegreeMinuteSeconds;
    /**
     * Constructor method for GeoCoordinatesType
     * @uses GeoCoordinatesType::setGoogle()
     * @uses GeoCoordinatesType::setDecimalDegree()
     * @uses GeoCoordinatesType::setDegreeMinuteSeconds()
     * @param \StructType\GeoCoordinatesGoogleType $google
     * @param \StructType\GeoCoordinatesDecimalDegreeType $decimalDegree
     * @param \StructType\GeoCoordinatesDegreeMinuteSecondsType $degreeMinuteSeconds
     */
    public function __construct(\StructType\GeoCoordinatesGoogleType $google = null, \StructType\GeoCoordinatesDecimalDegreeType $decimalDegree = null, \StructType\GeoCoordinatesDegreeMinuteSecondsType $degreeMinuteSeconds = null)
    {
        $this
            ->setGoogle($google)
            ->setDecimalDegree($decimalDegree)
            ->setDegreeMinuteSeconds($degreeMinuteSeconds);
    }
    /**
     * Get Google value
     * @return \StructType\GeoCoordinatesGoogleType|null
     */
    public function getGoogle()
    {
        return $this->Google;
    }
    /**
     * Set Google value
     * @param \StructType\GeoCoordinatesGoogleType $google
     * @return \StructType\GeoCoordinatesType
     */
    public function setGoogle(\StructType\GeoCoordinatesGoogleType $google = null)
    {
        $this->Google = $google;
        return $this;
    }
    /**
     * Get DecimalDegree value
     * @return \StructType\GeoCoordinatesDecimalDegreeType|null
     */
    public function getDecimalDegree()
    {
        return $this->DecimalDegree;
    }
    /**
     * Set DecimalDegree value
     * @param \StructType\GeoCoordinatesDecimalDegreeType $decimalDegree
     * @return \StructType\GeoCoordinatesType
     */
    public function setDecimalDegree(\StructType\GeoCoordinatesDecimalDegreeType $decimalDegree = null)
    {
        $this->DecimalDegree = $decimalDegree;
        return $this;
    }
    /**
     * Get DegreeMinuteSeconds value
     * @return \StructType\GeoCoordinatesDegreeMinuteSecondsType|null
     */
    public function getDegreeMinuteSeconds()
    {
        return $this->DegreeMinuteSeconds;
    }
    /**
     * Set DegreeMinuteSeconds value
     * @param \StructType\GeoCoordinatesDegreeMinuteSecondsType $degreeMinuteSeconds
     * @return \StructType\GeoCoordinatesType
     */
    public function setDegreeMinuteSeconds(\StructType\GeoCoordinatesDegreeMinuteSecondsType $degreeMinuteSeconds = null)
    {
        $this->DegreeMinuteSeconds = $degreeMinuteSeconds;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\GeoCoordinatesType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
